unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, phGant, ImgList, phGrid,
  phGridTree, phBabGridView, phGanttPrinting, Printers;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    G1: TphGant;
    ImageList1: TImageList;
    procedure FormShow(Sender: TObject);
    procedure GridInitTreeSubDataList(aGrid: TphGrid;
      aGridTree: TphGridTree;
      aDataEntity_GridTreeNode: TphDataEntity_GridTreeNode);
    procedure G1ChangeDataEntity_GantTime(theGant: TphGant_ComBasic;
      theDataEntity: TphDataEntity_GantTime);
    procedure BitBtn1Click(Sender: TObject);
    procedure G1PrintToHdcNewPage(theGant: TphGant_ComBasic;
      aPageNo: Integer; var pageHeight, pageWidht: Integer; var goahead,
      render: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses phDataEntityPack;

{$R *.dfm}

procedure TForm1.FormShow(Sender: TObject);
var
    i,j,h : integer;
    SDate : TDateTime;
begin
    {Just Filling up the Gantt}
    h:=0;
    g1.DateScaler.Start:=date;
    g1.DateScaler.Stop:=date+10;
    for i:=1 to 30 do
    begin
        g1.GridNode_Add(nil);
        g1.Grid.SetText(g1.Grid.Cell[0,i],'Line '+inttostr(i));
        for j:=1 to 2 do
        begin
            sDate:=date+Random(10);
            inc(h);
            with G1.GridNode_AddGantTime(g1.RowList.Rows[i-1].GridTreeNode,0) do
            begin                //what is the last parameter for ??? (the Zero)

//Answer# The last param is a layer index. You have many drawing layers and control what is drawn on what. Usefull if different time items occupy the same space
                Style:=gtsLine;
                TextCollection.AddText(inttostr(h),1,100);
                Color:=clRed;
                CanEdit:=True;
                Start:=sDate;
                Stop:=sDate+1;
                UserIntegerReference:=j
            end;
            inc(h);
            with G1.GridNode_AddGantTime(g1.RowList.Rows[i-1].GridTreeNode,0) do
            begin
                ImageIndex:=Random(3);
                Style:=gtsImage;
                TextCollection.AddText(inttostr(h),0,100);
                CanEdit:=False;
                Start:=sDate;
                Stop:=sDate;
                UserIntegerReference:=j;
                FixedSize:=16;
            end;
        end;
    end;
end;

procedure TForm1.GridInitTreeSubDataList(aGrid: TphGrid;
  aGridTree: TphGridTree;
  aDataEntity_GridTreeNode: TphDataEntity_GridTreeNode);
var
  i,n : integer;
begin
    n:=aDataEntity_GridTreeNode.AxisContentItem.ListIndex;
    if aDataEntity_GridTreeNode.Level=0 then
    begin
        for i:=1 to 3 do
        begin
            inc(n);
            g1.GridNode_Add(aDataEntity_GridTreeNode);
            g1.Grid.SetText(g1.Grid.Cell[0,n],'SubLine '+inttostr(i));
        end;
    end;
    if not G1.Grid.IsPrinting then
      showmessage('The value of the cell you choose to expand is '+g1.Grid.GetText(g1.Grid.Cell[0,aDataEntity_GridTreeNode.AxisContentItem.ListIndex]));

    //Answer#    g1.Grid.GetText(g1.Grid.Cell[0,aDataEntity_GridTreeNode.AxisContentItem.ListIndex]);
end;

procedure TForm1.G1ChangeDataEntity_GantTime(theGant: TphGant_ComBasic;
  theDataEntity: TphDataEntity_GantTime);
var
  i:integer;
begin
    //showmessage('How do I change the image position too when I move a line ???');
    //Answer#
    if theDataEntity.Style=gtsLine then
    begin
      for i:=0 to theDataEntity.OwningDataList.Count-1 do
      begin
        if ((theDataEntity.OwningDataList[i] as TphDataEntity_GantTime).Style=gtsImage) and
          ((theDataEntity.OwningDataList[i] as TphDataEntity_GantTime).UserIntegerReference=theDataEntity.UserIntegerReference) then
        begin
          (theDataEntity.OwningDataList[i] as TphDataEntity_GantTime).Start:=theDataEntity.Start;
        end;
      end;

    end;

    {************************* IDEAS ***********************}
(*    if theDataEntity.Style=gtsLine then
    begin
       {This looked like a good solution but it has problems in lines (2,9,10,11) any ideas}
       (theDataEntity.OwningDataList[thedataEntity.ListIndex+1] as TphDataEntity_GantTime).Start:=theDataEntity.Start;
    end;*)

    {Another idea was giving a unique text[0] so I could use it like this but problems again}
{     for i:=0 to theDataEntity.OwningDataList.Count-1 do
     begin
          if (theDataEntity.OwningDataList[i] as TphDataEntity_GantTime).TextCollection.Text[0].Text=
              inttostr(strtoint(theDataEntity.textCollection.text[0].text)-1) then
          begin
              (theDataEntity.OwningDataList[i] as TphDataEntity_GantTime).Start:=theDataEntity.Start;
              (theDataEntity.OwningDataList[i] as TphDataEntity_GantTime).Stop:=(theDataEntity.OwningDataList[i] as TphDataEntity_GantTime).Start;
          end;
     end;}

end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  usedwidth,
  usedHeight:integer;
begin
  //showmessage('I have no idea how to do this ???');
  //Answer#
  Printer.BeginDoc;
  Printer.Handle;
  TphPrintGantt.PrintWithGrid(G1,Printer.Handle,10,10,2,2,G1.TreeWidth,nil,-1,true,g1.Start,g1.Stop,g1.Width-g1.TreeWidth,g1.ScalerHeight,usedwidth,usedHeight,0,0,nil);
  Printer.EndDoc;
end;


procedure TForm1.G1PrintToHdcNewPage(theGant: TphGant_ComBasic;
  aPageNo: Integer; var pageHeight, pageWidht: Integer; var goahead,
  render: Boolean);
begin
    //Answer# continued

  pageHeight:=Printer.PageHeight;
  pageWidht:=Printer.PageWidth;
  goahead:=true;
  render:=true;
  if aPageNo>1 then
    Printer.NewPage;

end;

end.
