unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  BoldHandle, BoldUMLModelLink, BoldUMLRose98Link, BoldAbstractModel,
  BoldModel, BoldHandles, BoldSubscription, BoldSystemHandle,
  phOffscreenPaint, phBabGridView, phGrid, phGrid_BA, ExtCtrls, phGant,
  phGant_BA, Menus, StdCtrls, BoldExpressionHandle, BoldRootedHandles,
  BoldAbstractListHandle, BoldCursorHandle, BoldListHandle, phSchema,
  phSchema_BA, phBoldListTracker,BoldControlPack, BoldElements,
  BoldNumericControlPack,phScaler;

type
  TForm1 = class(TForm)
    BoldSystemHandle1: TBoldSystemHandle;
    BoldSystemTypeInfoHandle1: TBoldSystemTypeInfoHandle;
    BoldModel1: TBoldModel;
    phGant_BA1: TphGant_BA;
    phGrid_BA1: TphGrid_BA;
    PopupMenu1: TPopupMenu;
    AddTreeItem1: TMenuItem;
    RemoveTreeItem1: TMenuItem;
    N1: TMenuItem;
    AddTimeItemLayer1: TMenuItem;
    RemoveTimeItem1: TMenuItem;
    AddTimeItemLayer0: TMenuItem;
    BoldUMLRoseLink1: TBoldUMLRoseLink;
    BLHRooms: TBoldListHandle;
    BEHSelectedRoom: TBoldExpressionHandle;
    BLHBookings: TBoldListHandle;
    BLHBookingsSelectedRoom: TBoldListHandle;
    phBoldListTracker1: TphBoldListTracker;
    phSchema_BA1: TphSchema_BA;
    phSchema_BA2: TphSchema_BA;
    phGrid_BA2: TphGrid_BA;
    Button1: TButton;
    Button2: TButton;
    BASIRColumns: TBoldAsIntegerRenderer;
    BAIRDays: TBoldAsIntegerRenderer;
    Label1: TLabel;
    Label2: TLabel;
    procedure AddTreeItem1Click(Sender: TObject);
    procedure RemoveTreeItem1Click(Sender: TObject);
    procedure RemoveTimeItem1Click(Sender: TObject);
    procedure AddTimeItemLayer1Click(Sender: TObject);
    procedure AddTimeItemLayer0Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure phBoldListTracker1InsertRow(caller: TComponent;
      aRowFollower: TBoldFollower);
    procedure phBoldListTracker1DeleteRow(caller: TComponent;
      aRowFollower: TBoldFollower);
    procedure phBoldListTracker1AfterRowContentUpToDate(caller: TComponent;
      aRowFollower: TBoldFollower);
    procedure FormCreate(Sender: TObject);
    function BASIRColumnsGetAsInteger(Element: TBoldElement;
      Representation: Integer; Expression: String): Integer;
    procedure BASIRColumnsSubscribe(Element: TBoldElement;
      Representation: Integer; Expression: String;
      Subscriber: TBoldSubscriber);
    function BAIRDaysGetAsInteger(Element: TBoldElement;
      Representation: Integer; Expression: String): Integer;
    procedure BAIRDaysSubscribe(Element: TBoldElement;
      Representation: Integer; Expression: String;
      Subscriber: TBoldSubscriber);
  private
    fMainDate:TDatetime;
    procedure AddTimeItemOnLayer(i: integer);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses BATestClasses;

{$R *.DFM}

var
  g:integer=0;
procedure TForm1.AddTreeItem1Click(Sender: TObject);
var
  ti:TTreeItem;
begin
  ti:=TTreeItem.Create(nil);
  inc(g);
  ti.Text:='<newitem>'+IntToStr(g);
  ti.LayerItems.AddNew.IndexNo:=0;
  ti.LayerItems.AddNew.IndexNo:=1;
  if PopupMenu1.PopupComponent=phGant_BA1.TreeView then
  begin
    if Assigned(phGant_BA1.TreeView.CurrentDataEntity) then
    begin
      ti.TreeItem:=phGant_BA1.DataEntityToElement(phGant_BA1.TreeView.CurrentDataEntity) as TTreeItem;
    end;
  end
  else
  if PopupMenu1.PopupComponent=phGrid_BA1 then
  begin
    ti.TreeItem:=phGrid_BA1.GetFirstSelectedObject as TTreeItem;
  end;
end;

procedure TForm1.RemoveTreeItem1Click(Sender: TObject);
var
  ti:TTreeItem;
begin
  ti:=nil;
  if PopupMenu1.PopupComponent=phGant_BA1.TreeView then
  begin
    if Assigned(phGant_BA1.TreeView.CurrentDataEntity) then
    begin
      ti:=phGant_BA1.DataEntityToElement(phGant_BA1.TreeView.CurrentDataEntity) as TTreeItem;
    end;
  end
  else
  if PopupMenu1.PopupComponent=phGrid_BA1 then
  begin
    ti:=phGrid_BA1.GetFirstSelectedObject as TTreeItem;
  end;

  if Assigned(ti) then
  begin
    ti.UnLinkAll;
    ti.Delete;
  end;

end;

procedure TForm1.AddTimeItemOnLayer(i:integer);
var
  ti:TTreeItem;
  time:TTimeItem;
  gr:TGantRow;
begin
  gr:=phGant_BA1.RowList.FindRowFromY(phGant_BA1.GantMousePosition.y);
  if Assigned(gr)  then
  begin
    ti:=phGant_BA1.DataEntityToElement(gr.TreeNode) as TTreeItem;
    time:=TTimeItem.Create(nil);
    time.Start:=phGant_BA1.DateScaler.PixelToDate(phGant_BA1.GantMousePosition.x);
    time.Stop:=time.Start+2;
    time.LayerItem:=ti.LayerItems[i];
  end;
end;

procedure TForm1.RemoveTimeItem1Click(Sender: TObject);
var
  time:TTimeItem;
begin
  if PopupMenu1.PopupComponent=phGant_BA1.GA then
  begin
    if Assigned(phGant_BA1.ActiveDataEntity) then
    begin
      time:=phGant_BA1.DataEntityToElement(phGant_BA1.ActiveDataEntity) as TTimeItem;
      time.UnLinkAll;
      time.Delete;
    end;
  end;
end;

procedure TForm1.AddTimeItemLayer0Click(Sender: TObject);
begin
  if PopupMenu1.PopupComponent=phGant_BA1.GA then
    AddTimeItemOnLayer(0);
end;

procedure TForm1.AddTimeItemLayer1Click(Sender: TObject);
begin
  if PopupMenu1.PopupComponent=phGant_BA1.GA then
    AddTimeItemOnLayer(1);
end;


procedure TForm1.PopupMenu1Popup(Sender: TObject);
begin
  AddTreeItem1.Enabled:=(PopupMenu1.PopupComponent=phGant_BA1.TreeView) or (PopupMenu1.PopupComponent=phGrid_BA1);
  RemoveTreeItem1.Enabled:=(PopupMenu1.PopupComponent=phGant_BA1.TreeView) or (PopupMenu1.PopupComponent=phGrid_BA1);
  AddTimeItemLayer0.Enabled:=(PopupMenu1.PopupComponent=phGant_BA1.GA);
  AddTimeItemLayer1.Enabled:=(PopupMenu1.PopupComponent=phGant_BA1.GA);
  RemoveTimeItem1.Enabled:=(PopupMenu1.PopupComponent=phGant_BA1.GA) and Assigned(phGant_BA1.ActiveDataEntity);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  with TRoom.Create(nil) do
  begin
    Name:='New room';
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if Assigned(BEHSelectedRoom.Value) then
  begin
    with TBooking.Create(nil) do
    begin
      Start:=Round(phSchema_BA1.ScalerStart)+11/24;
      Stop:=Start+2/24;
      Room:=BEHSelectedRoom.Value as TRoom;
    end;
  end;
end;

procedure TForm1.phBoldListTracker1InsertRow(caller: TComponent;
  aRowFollower: TBoldFollower);
begin
  phSchema_BA1.AddColumn;
end;

procedure TForm1.phBoldListTracker1DeleteRow(caller: TComponent;
  aRowFollower: TBoldFollower);
begin
  phSchema_BA1.Columns.Delete(aRowFollower.index);
end;

procedure TForm1.phBoldListTracker1AfterRowContentUpToDate(
  caller: TComponent; aRowFollower: TBoldFollower);
begin
  phSchema_BA1.Columns[aRowFollower.index].Text:=(aRowFollower.Element as TRoom).Name;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  c:TphDataEntity_SchemaColumn;
begin

  c:=phSchema_BA2.AddColumn;
  c.Text:='Sun';
  c.OffsetDate:=0;
  c:=phSchema_BA2.AddColumn;
  c.Text:='Mon';
  c.OffsetDate:=1;
  c:=phSchema_BA2.AddColumn;
  c.Text:='Tue';
  c.OffsetDate:=2;
  c:=phSchema_BA2.AddColumn;
  c.Text:='Wed';
  c.OffsetDate:=3;
  c:=phSchema_BA2.AddColumn;
  c.Text:='Thu';
  c.OffsetDate:=4;
  c:=phSchema_BA2.AddColumn;
  c.Text:='Fri';
  c.OffsetDate:=5;
  c:=phSchema_BA2.AddColumn;
  c.Text:='Sat';
  c.OffsetDate:=6;

  phSchema_BA1.HiddenHours:=[thh00,thh01,thh02,thh03,thh04,thh05,thh06,thh07,thh08,thh18,thh19,thh20,thh21,thh22,thh23];
  phSchema_BA2.HiddenHours:=[thh00,thh01,thh02,thh03,thh04,thh05,thh06,thh07,thh08,thh18,thh19,thh20,thh21,thh22,thh23];

  fMainDate:=Trunc(Now);
  while DayOfWeek(fMainDate)<>1 do
    fMainDate:=fMainDate+1;
  phSchema_BA1.ScalerStop:=Trunc(fMainDate+7);
  phSchema_BA1.ScalerStart:=Trunc(fMainDate);

  phSchema_BA2.ScalerStop:=Trunc(fMainDate)+0.5;
  phSchema_BA2.ScalerStart:=Trunc(fMainDate);
end;

function TForm1.BASIRColumnsGetAsInteger(Element: TBoldElement;
  Representation: Integer; Expression: String): Integer;
begin
  Result := 0;
  if (Element is TBooking) then
  begin
    result:=BLHRooms.List.IndexOf((Element as TBooking).Room);
  end;
end;

procedure TForm1.BASIRColumnsSubscribe(Element: TBoldElement;
  Representation: Integer; Expression: String;
  Subscriber: TBoldSubscriber);
begin
  Element.SubscribeToExpression('room', Subscriber, False);
end;

function TForm1.BAIRDaysGetAsInteger(Element: TBoldElement;
  Representation: Integer; Expression: String): Integer;
begin
  Result := 0;
  if (Element is TBooking) then
  begin
    result:=DayOfWeek((Element as TBooking).Start)-1;
  end;
end;

procedure TForm1.BAIRDaysSubscribe(Element: TBoldElement;
  Representation: Integer; Expression: String;
  Subscriber: TBoldSubscriber);
begin
  Element.SubscribeToExpression('start', Subscriber, False);
end;

end.
