unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, BoldModel, BoldHandle, BoldPersistenceHandle,
  BoldPersistenceHandleDB, BoldPersistenceHandleBDE, BoldHandles,
  BoldSubscription, BoldSystemHandle,BoldSystem, BoldVariableHandle,
  BoldRootedHandles, BoldAbstractListHandle, BoldCursorHandle,
  BoldListHandle, BoldComboBox,BusinessClassesGwSG, BoldUMLModelLink,
  BoldUMLRose98Link, phOffscreenPaint, phBabGridView, phGrid_BA, ExtCtrls,
  Grids, BoldGrid,phBabGridContent, BoldAbstractModel, phGrid;

type
  TForm1 = class(TForm)
    BoldSystemHandle1: TBoldSystemHandle;
    BoldSystemTypeInfoHandle1: TBoldSystemTypeInfoHandle;
    BoldPersistenceHandleBDE1: TBoldPersistenceHandleBDE;
    BoldModel1: TBoldModel;
    BoldListHandle1: TBoldListHandle;
    BoldUMLRose98Link1: TBoldUMLRose98Link;
    Panel1: TPanel;
    Button2: TButton;
    phGrid_BA1: TphGrid_BA;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    fLayoutPropGreen:TLayoutProp;
    fLayoutPropRed:TLayoutProp;

    procedure BeforeRenderCell(theBabGridView:TBabGridView_Custom;theBabCell:TBabCell);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation


{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  i,ii:integer;
  aXElement:TXElement;
  aXAttribute:TXAttribute;
begin
  for ii:=0 to 5 do
  begin
    with TXElement.Create(nil) do
    begin
      Name:='Elem'+intToStr(ii);
      for i:=0 to 4 do
      begin
        aXAttribute:=TXAttribute.Create(nil);
        aXAttribute.Name:='Attr'+intToStr(i);
        xAttributes.Add(aXAttribute);
      end;

      for i:=0 to 2 do
      begin
        aXElement:=TXElement.Create(nil);
        aXElement.Name:='Elem'+intToStr(i);
        xNodes.Add(aXElement);
      end;
    end;
  end;
end;

procedure TForm1.BeforeRenderCell(theBabGridView:TBabGridView_Custom;theBabCell:TBabCell);
begin
  if (theBabCell.AxisContentItemX.ListIndex=1) then
  begin
    if (theBabCell.AxisContentItemY.ListIndex mod 2=0) then
    begin
      theBabCell.LayoutProp:=fLayoutPropGreen;
    end
    else
    begin
      theBabCell.LayoutProp:=fLayoutPropRed;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  phGrid_BA1.OnBeforeRenderCell:=BeforeRenderCell;
  fLayoutPropGreen:=TLayoutProp.Create;
  fLayoutPropRed:=TLayoutProp.Create;

  fLayoutPropGreen.BackColor:=clGreen;

  fLayoutPropRed.BackColor:=clRed;
  fLayoutPropRed.UseFontInfo:=TRUE;
  fLayoutPropRed.FontName:='Helvetica';
  fLayoutPropRed.FontSize:=14;
  fLayoutPropRed.FontColor:=clWhite;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(fLayoutPropGreen);
  FreeAndNil(fLayoutPropRed);
end;

end.
