unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MSXML_TLB, StdCtrls, phOffscreenPaint, phBabGridView,phBabGridContent, phGrid, phGrid_BA,
  ExtCtrls,XmlEditClasses, BoldSubscription, BoldElements, BoldControlPack,
  BoldStringControlPack,BoldSystem,BoldGenericListControlPack, Menus   ;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    phGrid_BA: TphGrid_BA;
    OpenDialog: TOpenDialog;
    ButtonOpen: TButton;
    BASR: TBoldAsStringRenderer;
    PopupMenu: TPopupMenu;
    NewdocumentItem: TMenuItem;
    NewtaggedsubnodeItem: TMenuItem;
    NewtextsubnodeItem: TMenuItem;
    NewattributeItem: TMenuItem;
    N1: TMenuItem;
    DeletedocumentItem: TMenuItem;
    DeletenodeItem: TMenuItem;
    DeleteattributeItem: TMenuItem;
    ButtonSave: TButton;
    SaveDialog: TSaveDialog;
    procedure ButtonOpenClick(Sender: TObject);
    function BASRGetAsString(Element: TBoldElement;
      Representation: Integer; Expression: String): String;
    function BASRMayModify(Element: TBoldElement; Representation: Integer;
      Expression: String; Subscriber: TBoldSubscriber): Boolean;
    procedure BASRSubscribe(Element: TBoldElement; Representation: Integer;
      Expression: String; Subscriber: TBoldSubscriber);
    procedure BASRHoldsChangedValue(Element: TBoldElement;
      Representation: Integer; Expression: String;
      Subscriber: TBoldSubscriber);
    procedure FormCreate(Sender: TObject);
    procedure BASRSetAsString(Element: TBoldElement; NewValue: String;
      Representation: Integer; Expression: String);
    procedure phGrid_BA1Columns2GetSubGridList(
      Sender: TBoldGenericListPart; Element: TBoldElement;
      Subscriber: TBoldSubscriber; ResultElement: TBoldIndirectElement;
      Resubscribe: Boolean);
    procedure PopupMenuPopup(Sender: TObject);
    procedure NewtaggedsubnodeItemClick(Sender: TObject);
    procedure NewdocumentItemClick(Sender: TObject);
    procedure NewtextsubnodeItemClick(Sender: TObject);
    procedure NewattributeItemClick(Sender: TObject);
    procedure DeletedocumentItemClick(Sender: TObject);
    procedure DeletenodeItemClick(Sender: TObject);
    procedure DeleteattributeItemClick(Sender: TObject);
    procedure ButtonSaveClick(Sender: TObject);
    procedure phGrid_BACellContentUpdate_After(aGrid: TphGrid;
      aColumn: TphGrid_Column; aBabCell: TBabCell);
  private
    fLayout0:TLayoutProp;
    fLayout1:TLayoutProp;
    fLayout2:TLayoutProp;
    fLayout3:TLayoutProp;
    function GetStrAndSub(Element: TBoldElement; Expression: String;
      Subscriber: TBoldSubscriber;var aMayModify:Boolean): String;
    function BoldTypeToUnknown(element: TBoldElement): IUnknown;
    function CreateBoldFromNode(aXMLNode: IXMLDOMNode): TBoldElement;
    procedure CascadeDestroy(aBE: TBoldElement);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses DM, FormTagName;


{$R *.DFM}

const
  kTagged='TAGGED';
  kTextOnly='TEXTONLY';



procedure TMainForm.CascadeDestroy(aBE:TBoldElement);
var
  i:integer;
  aXMLNode:IXMLDOMNode;
  aOwningElement:IXMLDOMElement;
  aXMLDocument:IXMLDOMDocument;
  unknown:IUnknown;
begin
  if aBE is TBoldObjectReference then
    aBE:=(aBE as TBoldObjectReference).BoldObject;

  unknown:=BoldTypeToUnknown(aBE);
  unknown.QueryInterface(IXMLDOMNode,aXMLNode);
  unknown.QueryInterface(IXMLDOMDocument,aXMLDocument);


  if aBE is TDoc then
  begin
    IUnknown((aBE as TDoc).MSXMLRef)._Release;
    (aBE as TDoc).MSXMLRef:=0;
    CascadeDestroy((aBE as TDoc).Element);
    (aBE as TDoc).UnLinkAll;
    (aBE as TDoc).Delete;
  end
  else if aBE is TElement then
  begin
    for i:=(aBE as TElement).Attributess.Count-1 downto 0 do
    begin
      CascadeDestroy((aBE as TElement).Attributess[i]);
    end;
    for i:=(aBE as TElement).Elements.Count-1 downto 0 do
    begin
      CascadeDestroy((aBE as TElement).Elements[i]);
    end;

    IUnknown((aBE as TElement).MSXMLRef)._Release;
    (aBE as TElement).MSXMLRef:=0;

    (aBE as TElement).UnLinkAll;
    (aBE as TElement).Delete;

    if Assigned(aXMLNode) and
      Assigned(aXMLNode.parentNode) then
      aXMLNode.parentNode.removeChild(aXMLNode);

  end
  else if aBE is TAttribute then
  begin
    aOwningElement:=(IUnknown((aBE as TAttribute).Element.MSXMLRef)) as IXMLDomElement;
    IUnknown((aBE as TAttribute).MSXMLRef)._Release;
    (aBE as TAttribute).MSXMLRef:=0;
    (aBE as TAttribute).UnLinkAll;
    (aBE as TAttribute).Delete;

    if Assigned(aOwningElement) then
      aOwningElement.removeAttribute((aXMLNode as IXMLDomAttribute).name);

  end;

end;

function TMainForm.CreateBoldFromNode(aXMLNode:IXMLDOMNode):TBoldElement;
  function localDoElement(aXMLNode:IUnknown):TElement;
  begin
    result:=TElement.Create(nil);
    result.MSXMLRef:=Integer(aXMLNode as IUnknown);
    aXMLNode._AddRef;
  end;
var
  i:integer;
  aXMLElement:IXMLDOMElement;
  aXMLText:IXMLDOMText;
  aXMLAttribute:IXMLDOMAttribute;
  aXMLDocument:IXMLDOMDocument;
begin
  result:=nil;
  aXMLNode.QueryInterface(IXMLDOMElement,aXMLElement);
  aXMLNode.QueryInterface(IXMLDOMText,aXMLText);
  aXMLNode.QueryInterface(IXMLDOMAttribute,aXMLAttribute);
  aXMLNode.QueryInterface(IXMLDOMDocument,aXMLDocument);



  if Assigned(aXMLDocument) then
  begin
    result:=TDoc.Create(nil);
    with result as TDoc do
    begin
      Name:=aXMLDocument.Get_url;
      MSXMLRef:=Integer(aXMLDocument as IUnknown);
      aXMLDocument._AddRef;
      if Assigned(aXMLDocument.documentElement) then
      begin
        Element:=CreateBoldFromNode(aXMLDocument.documentElement) as TElement;
      end;
    end;
  end
  else if Assigned(aXMLElement) then
  begin
    result:=localDoElement(aXMLNode);
    with result as TElement do
    begin
      Kind:=kTagged;
      Name:=aXMLElement.nodeName;

      for i:=0 to aXMLElement.childNodes.length-1 do
      begin
        Elements.Add(CreateBoldFromNode(aXMLElement.childNodes.item[i]) as TElement);
      end;

      for i:=0 to aXMLElement.attributes.length-1 do
      begin
        Attributess.Add(CreateBoldFromNode(aXMLElement.attributes.item[i]) as TAttribute);
      end;
    end;
  end
  else if Assigned(aXMLText) then
  begin
    result:=localDoElement(aXMLNode);
    with result as TElement do
    begin
      Kind:=kTextOnly;
      Value:=aXMLText.text;
    end;
  end
  else if Assigned(aXMLAttribute) then
  begin
    result:=TAttribute.Create(nil);
    with result as TAttribute do
    begin
      MSXMLRef:=Integer(aXMLAttribute as IUnknown);
      aXMLAttribute._AddRef;

      Name:=aXMLAttribute.nodeName;
      Value:=aXMLAttribute.nodeValue;
    end;
  end;
end;


procedure TMainForm.ButtonOpenClick(Sender: TObject);
var
  aXMLDocument:IXMLDOMDocument;
begin
  aXMLDocument:=CoDOMDocument.Create;
  aXMLDocument.async := false;
  aXMLDocument.validateOnParse := false;


  if OpenDialog.Execute then
  begin
    aXMLDocument.load(OpenDialog.FileName);
    CreateBoldFromNode(aXMLDocument);
  end;

end;

function TMainForm.BASRGetAsString(Element: TBoldElement;
  Representation: Integer; Expression: String): String;
var
  mayModify:Boolean;
begin
  Result := GetStrAndSub(Element,Expression,nil,mayModify);
end;

function TMainForm.BoldTypeToUnknown(element:TBoldElement):IUnknown;
begin
  result:=nil;
  if element is TElement then
    result:=IUnknown((Element as TElement).MSXMLRef)
  else if element is TAttribute then
    result:=IUnknown((Element as TAttribute).MSXMLRef)
  else if element is TDoc then
    result:=IUnknown((Element as TDoc).MSXMLRef)
end;

function TMainForm.GetStrAndSub(Element: TBoldElement;Expression: String;Subscriber: TBoldSubscriber;var aMayModify:Boolean): String;
begin
  aMayModify:=FALSE;
  if Element is TBoldObjectReference then
    Element:=(Element as TBoldObjectReference).BoldObject;
  if Expression='name' then
  begin
    if Element is TDoc then
    begin
      result:=(Element as TDoc).Name;
      if Assigned(Subscriber) then
        Element.SubscribeToExpression('name',Subscriber);
    end
    else
    if Element is TAttribute then
    begin
      result:=(Element as TAttribute).Name;
      if Assigned(Subscriber) then
        Element.SubscribeToExpression('name',Subscriber);
    end
    else
    if Element is TElement then
    begin
      aMayModify:=(Element as TElement).Kind=kTextOnly;
      result:=(Element as TElement).Name;
      if result='' then
        result:=(Element as TElement).Value;
      if Assigned(Subscriber) then
      begin
        Element.SubscribeToExpression('name',Subscriber);
        Element.SubscribeToExpression('value',Subscriber);
      end;

    end;

  end
  else
  if Expression='type' then
  begin
    if Element is TDoc then
    begin
      result:='DOC';
    end
    else
    if Element is TElement then
    begin
      result:=(Element as TElement).Kind;
      if Assigned(Subscriber) then
        Element.SubscribeToExpression('kind',Subscriber);
    end;
  end
  else
  if Expression='value' then
  begin
    aMayModify:=TRUE;
    if Element is TAttribute then
    begin
      result:=(Element as TAttribute).Value;
      if Assigned(Subscriber) then
        Element.SubscribeToExpression('value',Subscriber);
    end;
  end;


end;

function TMainForm.BASRMayModify(Element: TBoldElement;
  Representation: Integer; Expression: String;
  Subscriber: TBoldSubscriber): Boolean;
begin
  GetStrAndSub(Element,Expression,nil,result);
end;

procedure TMainForm.BASRSubscribe(Element: TBoldElement;
  Representation: Integer; Expression: String;
  Subscriber: TBoldSubscriber);
var
  mayModify:Boolean;
begin
  GetStrAndSub(Element,Expression,Subscriber,mayModify);

end;

procedure TMainForm.BASRHoldsChangedValue(Element: TBoldElement;
  Representation: Integer; Expression: String;
  Subscriber: TBoldSubscriber);
begin
  //
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin

  fLayout0:=TLayoutProp.Create;
  fLayout0.BackColor:=$004080FF;
  fLayout0.WrapTextAndFit:=TRUE;


  fLayout1:=TLayoutProp.Create;
  fLayout1.BackColor:=$00F4DEB9;

  fLayout2:=TLayoutProp.Create;
  fLayout2.BackColor:=$00DAF5D8;

  fLayout3:=TLayoutProp.Create;
  fLayout3.BackColor:=$00F5D8D8;
  fLayout3.MinHeight:=20;


end;

procedure TMainForm.BASRSetAsString(Element: TBoldElement;
  NewValue: String; Representation: Integer; Expression: String);
begin
  if (Element is TElement) and (Expression='name') then
  begin
    if ((Element as TElement).Kind=kTextOnly) then
    begin
      // Change of textnode
      (BoldTypeToUnknown(Element) as IXMLDOMText).Text:=NewValue;
      (Element as TElement).Value:=NewValue;
    end;
  end
  else
  if (Element is TAttribute) and (Expression='value') then
  begin
    (BoldTypeToUnknown(Element) as IXMLDOMAttribute).value:=NewValue;
    (Element as TAttribute).Value:=NewValue;
  end;

end;

procedure TMainForm.phGrid_BA1Columns2GetSubGridList(
  Sender: TBoldGenericListPart; Element: TBoldElement;
  Subscriber: TBoldSubscriber; ResultElement: TBoldIndirectElement;
  Resubscribe: Boolean);
begin
  if (Element is TElement) and ((Element as TElement).Kind=kTagged) then
  begin
    ResultElement.SetReferenceValue((Element as TElement).Attributess);
    (Element as TElement).SubscribeToExpression('attributess',Subscriber,TRUE);
  end;
end;

procedure TMainForm.PopupMenuPopup(Sender: TObject);
var
  element:TBoldElement;
begin
  element:=phGrid_BA.CellToElement(phGrid_BA.FocusedCell);
  if element is TBoldObjectReference then
    element:=(element as TBoldObjectReference).BoldObject;

  NewdocumentItem.Enabled:=TRUE;
  NewtaggedsubnodeItem.Enabled:=((element is TElement) and
                                ((element as TElement).Kind=kTagged));
  NewtextsubnodeItem.Enabled:=(element is TElement);
  NewattributeItem.Enabled:=((element is TElement) and
                                ((element as TElement).Kind=kTagged));

  DeletedocumentItem.Enabled:=(element is TDoc);
  DeletenodeItem.Enabled:=(element is TElement);
  DeleteattributeItem.Enabled:=(element is TAttribute);

end;

procedure TMainForm.NewtaggedsubnodeItemClick(Sender: TObject);
var
  element:TBoldElement;
  xxx:IXMLDOMNode;
begin
  TagName.MainLabel.Caption:='Enter tag name:';
  if TagName.ShowModal=mrOK then
  begin
    element:=phGrid_BA.CellToElement(phGrid_BA.FocusedCell);
    xxx:=(BoldTypeToUnknown(element) as IXMLDOMElement).ownerDocument.createElement(TagName.EditTagName.Text);
    (BoldTypeToUnknown(element) as IXMLDOMElement).appendChild(xxx);
    (element as TElement).Elements.Add(CreateBoldFromNode(xxx) as TElement);
  end;
end;

procedure TMainForm.NewdocumentItemClick(Sender: TObject);
var
  aXMLDocument:IXMLDOMDocument;
begin
  aXMLDocument:=CoDOMDocument.Create;
  aXMLDocument.async := false;
  aXMLDocument.validateOnParse := false;
  CreateBoldFromNode(aXMLDocument);
end;

procedure TMainForm.NewtextsubnodeItemClick(Sender: TObject);
var
  element:TBoldElement;
  xxx:IXMLDOMNode;
begin
  element:=phGrid_BA.CellToElement(phGrid_BA.FocusedCell);
  xxx:=(BoldTypeToUnknown(element) as IXMLDOMElement).ownerDocument.createTextNode('new text node');
  (BoldTypeToUnknown(element) as IXMLDOMElement).appendChild(xxx);
  (element as TElement).Elements.Add(CreateBoldFromNode(xxx) as TElement);
end;

procedure TMainForm.NewattributeItemClick(Sender: TObject);
var
  element:TBoldElement;
  xxx:IXMLDOMNode;
  l:integer;
  attribute:TAttribute;
begin
  TagName.MainLabel.Caption:='Attribute name:';
  if TagName.ShowModal=mrOK then
  begin
    element:=phGrid_BA.CellToElement(phGrid_BA.FocusedCell);
    l:=(BoldTypeToUnknown(element) as IXMLDOMElement).Get_attributes.length;
    (BoldTypeToUnknown(element) as IXMLDOMElement).setAttribute(TagName.EditTagName.Text,'novalue');
    if (BoldTypeToUnknown(element) as IXMLDOMElement).Get_attributes.length>l then
    begin
      xxx:=(BoldTypeToUnknown(element) as IXMLDOMElement).getAttributeNode(TagName.EditTagName.Text);
      attribute:=CreateBoldFromNode(xxx) as TAttribute;
      attribute.Element:=(element as TElement);
    end;
  end;
end;

procedure TMainForm.DeletedocumentItemClick(Sender: TObject);
begin
  CascadeDestroy(phGrid_BA.CellToElement(phGrid_BA.FocusedCell));
end;

procedure TMainForm.DeletenodeItemClick(Sender: TObject);
begin
  CascadeDestroy(phGrid_BA.CellToElement(phGrid_BA.FocusedCell));
end;

procedure TMainForm.DeleteattributeItemClick(Sender: TObject);
begin
  CascadeDestroy(phGrid_BA.CellToElement(phGrid_BA.FocusedCell));
end;


procedure TMainForm.ButtonSaveClick(Sender: TObject);
var
  xmlDomNode:IXMLDomNode;
  xmlDomDocument:IXMLDomDocument;
  ele:TBoldElement;
begin
  ele:=phGrid_BA.CellToElement(phGrid_BA.FocusedCell);
  if ele is TBoldObjectReference then
    ele:=(ele as TBoldObjectReference).BoldObject;
    
  xmlDomNode:=BoldTypeToUnknown(ele) as IXMLDomNode;
  if Assigned(xmlDomNode) then
  begin
    if Assigned(xmlDomNode.ownerDocument) then
    begin
      xmlDomDocument:=xmlDomNode.ownerDocument;
    end
    else
    if Assigned(xmlDomNode.parentNode) then
    begin
      xmlDomDocument:=xmlDomNode.parentNode as IXMLDomDocument;
    end
    else
    begin
      xmlDomDocument:=xmlDomNode as IXMLDomDocument;
    end;


    if Assigned(xmlDomDocument) then
    begin
      if SaveDialog.Execute then
        xmlDomDocument.save(SaveDialog.FileName);
    end;
  end;

end;

procedure TMainForm.phGrid_BACellContentUpdate_After(aGrid: TphGrid;
  aColumn: TphGrid_Column; aBabCell: TBabCell);
var
  element:TBoldElement;
begin
  if aBabCell is TBabSimpleCell then
  begin
    element:=phGrid_BA.CellToElement(aBabCell);
    if element is TBoldObjectReference then
      element:=(element as TBoldObjectReference).BoldObject;

    if element is TElement then
    begin
      if (element as TElement).Kind=kTextOnly then
        aBabCell.LayoutProp:=fLayout0
      else
        aBabCell.LayoutProp:=fLayout1;
    end
    else if element is TDoc then
      aBabCell.LayoutProp:=fLayout2
    else if element is TAttribute then
      aBabCell.LayoutProp:=fLayout3;
  end;
end;

end.
