 //---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "GanttView.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "phGant"
#pragma link "BaseView"
#pragma link "phGant"
#pragma resource "*.dfm"
TGanttView *GanttView;
//---------------------------------------------------------------------------
__fastcall TGanttView::TGanttView(TComponent* Owner, VirtuelTestDatas &virtuelTestDatas,bool Virtual)
   : TBaseView(Owner)
{
   isvirtual=Virtual;

   TphGrid_Column *phGrid_Column;
   phGant1->UseGridNotTree = true;

   phGant1->UseGridNotTree = true;
   phGant1->Grid->HasHeaders = true;
   phGant1->Grid->HasInfoCol = false;
   phGant1->Grid->RowSelect = true;
   phGant1->DateScaler->Start = Now();
   phGant1->DateScaler->Stop = Now()+30;
   phGant1->ShowButtonsTree = false;
   phGant1->ShowLinesTree = false;

   phGrid_Column = phGant1->Grid->AddColumn();
   phGrid_Column->Kind = tckSimpleEdit;
   phGrid_Column->HeaderText = "Id";
   phGrid_Column->Width = 50;
   phGrid_Column->SortEnable=true;

   phGrid_Column = phGant1->Grid->AddColumn();
   phGrid_Column->Kind = tckDate;
   phGrid_Column->HeaderText = "Date";
   phGrid_Column->Width = 50;
   phGrid_Column->SortEnable=true;

   phGant1->TreeWidth = 250;
   VirtuelDataChanged(virtuelTestDatas);
}

void TGanttView::VirtuelDataChanged(VirtuelTestDatas &x)
{
   TWaitCursor waitCursor;
   microtimer timer;

   virtuelTestDatas = x;

   phGant1->BeginUpdate();
   int count(virtuelTestDatas.size());
   phGant1->Grid->GetTree()->RootDataEntities->Clear();
   if (isvirtual)
   {
     phGant1->Grid->GetTree()->RootDataEntities->AddUnloaded(count);
   }
   else
   {
     for (int i=0; i!=count; ++i) {
        phGant1->GridNode_Add(0);
        VirtuelTestData *p = virtuelTestDatas[i];
        phGant1->Grid->SetText(phGant1->Grid->Cell[1][i+1], IntToStr(p->id));
        phGant1->Grid->SetText(phGant1->Grid->Cell[2][i+1], IntToStr(p->date));
     }
   }
   phGant1->EndUpdate();
   StatusBar1->SimpleText = "Updated data in " + IntToStr(timer.stop())+ " ms";
}

//---------------------------------------------------------------------------



int __stdcall CustomSortCompareId(long Item1, long Item2, long direction)

{
   VirtuelTestData *data1 = reinterpret_cast<VirtuelTestData*>(reinterpret_cast<TListItem*>(Item1)->Data);
   VirtuelTestData *data2 = reinterpret_cast<VirtuelTestData*>(reinterpret_cast<TListItem*>(Item2)->Data);
   int Compare = 0;
   if (data1->id<data2->id)
      Compare = -1;
   else if (data1->id>data2->id)
      Compare = 1;

   if (direction)
      return Compare;
   else
      return -Compare;
}

void __fastcall TGanttView::ListView1ColumnClick(TObject *Sender,
      TListColumn *Column)
{
   TWaitCursor waitCursor;
/*
   sortDirections[Column->Index] = !sortDirections[Column->Index];

   switch (Column->Index) {
      case 0:    ListView1->CustomSort(CustomSortCompareId, sortDirections[Column->Index]); break;
      case 1:    ListView1->CustomSort(CustomSortCompareSize, sortDirections[Column->Index]); break;
   }
   ListView1->Items->BeginUpdate();
   ListView1->Items->EndUpdate();
*/
}
//---------------------------------------------------------------------------

void __fastcall TGanttView::FormCreate(TObject *Sender)
{
/*
   for (int i=0; ListView1->Columns->Count!=i; ++i)
      sortDirections.push_back(true);
*/
}
//---------------------------------------------------------------------------


void __fastcall TGanttView::phGant1VirtualLoad_Grid(
      TBabGridCell *theCaller, TAxisContentItem *theAxisItem,
      bool theRowNotColumn)
{
  if (theRowNotColumn)
  {
    int fixed = theAxisItem->AxisContentList->FixedItems;
    int i = theAxisItem->ListIndex() - fixed;
    VirtuelTestData *p = virtuelTestDatas[i];

    phGant1->Grid->SetText(phGant1->Grid->Cell[1][i+fixed], IntToStr(p->id));
    phGant1->Grid->SetText(phGant1->Grid->Cell[2][i+fixed], IntToStr(p->date));



    TphDataEntity_GantTime *timeitem = phGant1->GridNode_AddGantTime(
                phGant1->Grid->AxisContentItemToGridTreeNode(theAxisItem),0);

    timeitem->Start = (double) p->date;
    timeitem->Stop=(double) (p->date+5);
    timeitem->Style =gtsPipe ;
    timeitem->Color = clYellow;
  }
}
//---------------------------------------------------------------------------

void __fastcall TGanttView::phGant1VirtualUnLoad_Grid(
      TBabGridCell *theCaller, TAxisContentItem *theAxisItem,
      bool theRowNotColumn, bool UnloadPerform, bool &CanUnload)
{
  if (isvirtual && theRowNotColumn)
  {
    CanUnload=true;
  }
  else
  {
    CanUnload=false;
  }
}
//---------------------------------------------------------------------------

void __fastcall TGanttView::phGant1ColumnSort_Grid(TphGrid *aGrid,
      TphGrid_Column *aColumn, bool aUpNotDown, bool &GoOnInternalSort)
{
   if (isvirtual)
   {
     GoOnInternalSort=false;
     aGrid->MainGrid->AxisContentListY->UnloadAll(); // On next Paint, all visible data vill be reloaded

     /* Resort all content here
     switch (aColumn->Index) {
        case 0:    ListView1->CustomSort(CustomSortCompareId, sortDirections[Column->Index]); break;
        case 1:    ListView1->CustomSort(CustomSortCompareSize, sortDirections[Column->Index]); break;
     }*/
   }
}
//---------------------------------------------------------------------------

