 //---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ListViewNonVirtuel.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "BaseView"
#pragma resource "*.dfm"
TListViewNonVirtuel *ListViewNonVirtuel;
//---------------------------------------------------------------------------
__fastcall TListViewNonVirtuel::TListViewNonVirtuel(TComponent* Owner, VirtuelTestDatas &virtuelTestDatas)
   : TBaseView(Owner)
{
   VirtuelDataChanged(virtuelTestDatas);
}

void TListViewNonVirtuel::VirtuelDataChanged(VirtuelTestDatas &virtuelTestDatas)
{
   TWaitCursor waitCursor;
   microtimer timer;
   ListView1->Items->BeginUpdate();
   ListView1->Items->Clear();
   for (unsigned int i=0; virtuelTestDatas.size()!=i; ++i) {
      TListItem *Item = ListView1->Items->Add();
      Item->Data = virtuelTestDatas[i];
      Item->Caption = virtuelTestDatas[i]->id;
      Item->SubItems->Add(IntToStr(virtuelTestDatas[i]->date));
   }
   ListView1->Items->EndUpdate();
   StatusBar1->SimpleText = "Updated data in " + IntToStr(timer.stop())+ " ms";

}

//---------------------------------------------------------------------------



int __stdcall CustomSortCompareId(long Item1, long Item2, long direction)

{
   VirtuelTestData *data1 = reinterpret_cast<VirtuelTestData*>(reinterpret_cast<TListItem*>(Item1)->Data);
   VirtuelTestData *data2 = reinterpret_cast<VirtuelTestData*>(reinterpret_cast<TListItem*>(Item2)->Data);
   int Compare = 0;
   if (data1->id<data2->id)
      Compare = -1;
   else if (data1->id>data2->id)
      Compare = 1;

   if (direction)
      return Compare;
   else
      return -Compare;
}

int __stdcall CustomSortCompareDate(long Item1, long Item2, long direction)

{
   VirtuelTestData *data1 = reinterpret_cast<VirtuelTestData*>(reinterpret_cast<TListItem*>(Item1)->Data);
   VirtuelTestData *data2 = reinterpret_cast<VirtuelTestData*>(reinterpret_cast<TListItem*>(Item2)->Data);
   int Compare = 0;
   if (data1->date<data2->date)
      Compare = -1;
   else if (data1->date>data2->date)
      Compare = 1;

   if (direction)
      return Compare;
   else
      return -Compare;
}

void __fastcall TListViewNonVirtuel::ListView1ColumnClick(TObject *Sender,
      TListColumn *Column)
{
   TWaitCursor waitCursor;

   sortDirections[Column->Index] = !sortDirections[Column->Index];

   switch (Column->Index) {
      case 0:    ListView1->CustomSort(CustomSortCompareId, sortDirections[Column->Index]); break;
      case 1:    ListView1->CustomSort(CustomSortCompareDate, sortDirections[Column->Index]); break;
   }
   ListView1->Items->BeginUpdate();
   ListView1->Items->EndUpdate();
}
//---------------------------------------------------------------------------

void __fastcall TListViewNonVirtuel::FormCreate(TObject *Sender)
{
   for (int i=0; ListView1->Columns->Count!=i; ++i)
      sortDirections.push_back(true);
}
//---------------------------------------------------------------------------

