#ifndef __virtueldata_h
#define __virtueldata_h

#include <vector>
#include <string>
class VirtuelTestData {
public:
   VirtuelTestData(void);
   const int id;
   std::string task;
   std::string unit;
   unsigned long date;
private:
   static int count;
};

inline std::string __itoa(int v)
{
   char buffer[33];
   itoa(v, buffer, 10);
   return std::string(buffer);
}

VirtuelTestData::VirtuelTestData(void) :
   id(++count), date(random(1000000)),
   task(__itoa(random(1000000))), unit(__itoa(random(10)))
{

}

class TWaitCursor
{
public:
   TWaitCursor(void) : OldCursor(SetCursor(LoadCursor(NULL,IDC_WAIT))){}
   ~TWaitCursor(void){SetCursor(OldCursor);}
private:
   HCURSOR OldCursor;
};

class CompareVirtuelTestData
{
public:
   CompareVirtuelTestData(bool direction):direction(direction){}
   virtual bool operator()(const VirtuelTestData *x, const VirtuelTestData *y) = 0;
protected:
   const bool direction;
};

class CompareId : public CompareVirtuelTestData
{
public:
   CompareId(bool direction):CompareVirtuelTestData(direction){}
   bool operator() (const VirtuelTestData *x, const VirtuelTestData *y) {
      if (direction)
         return x->id<y->id;
      else
         return y->id<x->id;
   }
};

class CompareDate : public CompareVirtuelTestData
{
public:
   CompareDate(bool direction):CompareVirtuelTestData(direction){}
   bool operator() (const VirtuelTestData *x, const VirtuelTestData *y) {
      if (direction)
         return x->date<y->date;
      else
         return y->date<x->date;
   }
};

typedef std::vector<VirtuelTestData*> VirtuelTestDatas;
extern VirtuelTestDatas virtuelTestDatas;

#include <sys\timeb.h>

class microtimer
{
protected:
	timeb tms;
	timeb tme;
public:
	microtimer() {
		ftime(&tms);
	}
	void start() {
		ftime(&tms);
	}
	unsigned long stop() {
		ftime(&tme);
		return  (1000L*tme.time+tme.millitm-60000L*tme.timezone+3600000L*tme.dstflag)
				 -(1000L*tms.time+tms.millitm-60000L*tms.timezone+3600000L*tms.dstflag);
	}
};
#endif //#define __virtueldata_h
