unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, phSchema, phGant, ComCtrls, Menus,phScaler,phBabGridContent,
  phGridTree, StdCtrls,phGraphStuff;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    phGant1: TphGant;
    phSchema1: TphSchema;
    Panel2: TPanel;
    Panel1: TPanel;
    PopupMenu1: TPopupMenu;
    Addrow1: TMenuItem;
    Removerow1: TMenuItem;
    N1: TMenuItem;
    Addtimeitem1: TMenuItem;
    Removetimeitem1: TMenuItem;
    PopupMenu2: TPopupMenu;
    AddColumn1: TMenuItem;
    RemoveColumn1: TMenuItem;
    N2: TMenuItem;
    AddTimeitem2: TMenuItem;
    Removetimeitem2: TMenuItem;
    N3: TMenuItem;
    Flipview1: TMenuItem;
    TabSheet3: TTabSheet;
    phGant_VL: TphGant;
    Panel3: TPanel;
    ButtonVirtualLoad: TButton;
    ButtonClear: TButton;
    ButtonClearTimeItems: TButton;
    LabelDrag: TLabel;
    ButtonRowHeight: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Addrow1Click(Sender: TObject);
    procedure Removerow1Click(Sender: TObject);
    procedure Addtimeitem1Click(Sender: TObject);
    procedure AddColumn1Click(Sender: TObject);
    procedure RemoveColumn1Click(Sender: TObject);
    procedure AddTimeitem2Click(Sender: TObject);
    procedure Removetimeitem2Click(Sender: TObject);
    procedure Flipview1Click(Sender: TObject);
    procedure phSchema1ScalerUserDrawBackground(caller: TphDateScaler;
      aCanvas: TCanvas; aRect: TRect);
    procedure phSchema1ScalerUserDrawForeground(caller: TphDateScaler;
      aCanvas: TCanvas; aRect: TRect);
    procedure DateScalerUserDrawBackground(caller: TphDateScaler;
      aCanvas: TCanvas; aRect: TRect);
    procedure DateScalerUserDrawForeground(caller: TphDateScaler;
      aCanvas: TCanvas; aRect: TRect);
    procedure ButtonVirtualLoadClick(Sender: TObject);
    procedure phGant_VLVirtualLoad_Grid(theCaller: TBabGridCell;
      theAxisItem: TAxisContentItem; theRowNotColumn: Boolean);
    procedure phGant_VLVirtualUnLoad_Grid(theCaller: TBabGridCell;
      theAxisItem: TAxisContentItem; theRowNotColumn,
      UnloadPerform: Boolean; var CanUnload: Boolean);
    procedure ButtonClearClick(Sender: TObject);
    procedure ButtonClearTimeItemsClick(Sender: TObject);
    procedure LabelDragStartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure GridDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure GridDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure phGant1TimeChangeRow(theGant: TphGant_ComBasic;
      theDataEntity: TphDataEntity_GantTime; theRow, theNewRow: TGantRow;
      theStartDate, theStopDate: TDateTime);
    procedure ButtonRowHeightClick(Sender: TObject);
  private
    procedure SampleText(aCanvas: TCanvas; aColor: TColor; aText: String;
      aPos: TPoint);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  phGant1.DateScaler.LookAndFeel:=tlfBoxed;
  phGant1.DateScaler.ScrollButtons:=tsbSmall;
  phGant1.UseGridNotTree:=TRUE;

  phSchema1.AddColumn.Text:='New column';
  phSchema1.Scaler.ScrollButtons:=tsbSmall;
  phSchema1.Scaler.LookAndFeel:=tlfBoxed;
  phSchema1.Scaler.VerticalText:=TRUE;

end;

procedure TForm1.Addrow1Click(Sender: TObject);
var
  aGridTreeNode:TphDataEntity_GridTreeNode;
  aCell:TBabCell;
begin

  if Assigned(phGant1.ActiveGantRow) then
    aGridTreeNode:=phGant1.GridNode_Add(phGant1.ActiveGantRow.GridTreeNode)
  else
    aGridTreeNode:=phGant1.GridNode_Add(nil);


  aCell:=phGant1.Grid.Cell[0,aGridTreeNode.AxisContentItem.ListIndex];
  phGant1.Grid.SetText(aCell,'a new row');

end;

procedure TForm1.Removerow1Click(Sender: TObject);
begin
  if Assigned(phGant1.Grid.FocusedCell) then
    phGant1.Grid.GetTree.RemoveDataEntity(phGant1.Grid.AxisContentItemToGridTreeNode(phGant1.Grid.FocusedCell.AxisContentItemY));
end;

procedure TForm1.Addtimeitem1Click(Sender: TObject);
var
  aTimeItem:TphDataEntity_Ganttime;
begin
  if Assigned(phGant1.Grid.FocusedCell) then
  begin
    aTimeItem:=phGant1.GridNode_AddGantTime(phGant1.Grid.AxisContentItemToGridTreeNode(phGant1.Grid.FocusedCell.AxisContentItemY),0);
    aTimeItem.Start:=phGant1.DateScaler.Start+5;
    aTimeItem.Stop:=phGant1.DateScaler.Start+15;
    aTimeItem.Color:=Random(65000);
    aTimeItem.Style:=gtsPipe;

  end;
end;

procedure TForm1.AddColumn1Click(Sender: TObject);
begin
  phSchema1.AddColumn.Text:='New column';
end;

procedure TForm1.RemoveColumn1Click(Sender: TObject);
begin
  if phSchema1.MouseDownColumn<>nil then
    phSchema1.RemoveColumn(phSchema1.MouseDownColumn);
end;

procedure TForm1.AddTimeitem2Click(Sender: TObject);
var
  aphSchemaTime:TphDataEntity_SchemaTime;
begin
  if phSchema1.MouseDownColumn<>nil then
  begin
    aphSchemaTime:=phSchema1.AddSchemaTime(0);
    aphSchemaTime.Start:=phSchema1.MouseDownDateTime-1;
    aphSchemaTime.Stop:=phSchema1.MouseDownDateTime-1;
    aphSchemaTime.Col:=phSchema1.MouseDownColumn.ListIndex;
    aphSchemaTime.BackColor:=Random(65000);
  end;

end;

procedure TForm1.Removetimeitem2Click(Sender: TObject);
begin
  if Assigned(phSchema1.ActiveDataEntity) then
  begin
    phSchema1.RemoveSchemaTime(phSchema1.ActiveDataEntity);
  end;
end;

procedure TForm1.Flipview1Click(Sender: TObject);
begin
  phSchema1.FlipView:=not phSchema1.FlipView;
end;

procedure TForm1.SampleText(aCanvas:TCanvas;aColor:TColor;aText:String;aPos:TPoint);
begin
  aCanvas.Font.Size:=16;
  aCanvas.Font.Color:=aColor;
  aCanvas.Brush.Color:=clBlack;
  aCanvas.Brush.Style:=bsSolid;
  GStuff.RotateFont(aCanvas.Font,45);
  aCanvas.TextOut(aPos.x,aPos.Y,aText);
end;

procedure TForm1.phSchema1ScalerUserDrawBackground(caller: TphDateScaler;
  aCanvas: TCanvas; aRect: TRect);
begin
  SampleText(aCanvas,clBlue,'Back',Point(0,100));
end;

procedure TForm1.phSchema1ScalerUserDrawForeground(caller: TphDateScaler;
  aCanvas: TCanvas; aRect: TRect);
begin
  SampleText(aCanvas,clRed,'Front',Point(0,150));
end;

procedure TForm1.DateScalerUserDrawBackground(caller: TphDateScaler;
  aCanvas: TCanvas; aRect: TRect);
begin
  SampleText(aCanvas,clBlue,'Back',Point(100,30));
end;

procedure TForm1.DateScalerUserDrawForeground(caller: TphDateScaler;
  aCanvas: TCanvas; aRect: TRect);
begin
  SampleText(aCanvas,clRed,'Front',Point(150,30));
end;

procedure TForm1.ButtonVirtualLoadClick(Sender: TObject);
begin
  phGant_VL.Grid.GetTree.RootDataEntities.AddUnloaded(100000);
end;

procedure TForm1.phGant_VLVirtualLoad_Grid(theCaller: TBabGridCell;
  theAxisItem: TAxisContentItem; theRowNotColumn: Boolean);
var
  aNode:TphDataEntity_GridTreeNode;
  aGT:TphDataEntity_GantTime;
begin
  if theRowNotColumn then
  begin
    aNode:=phGant_VL.Grid.AxisContentItemToGridTreeNode(theAxisItem);

    phGant_VL.Grid.SetText(phGant_VL.Grid.Cell[0,theAxisItem.ListIndex],'Row no'+intToStr(theAxisItem.ListIndex));

    aGT:=phGant_VL.GridNode_AddGantTime(aNode,0);
    aGT.Start:=phGant_VL.Start+30+Sin(theAxisItem.ListIndex/5)*20;
    aGT.Stop:=aGT.Start+2;
    aGT.Style:=gtsPipe;
    aGT.Color:=clBlue;

    aGT:=phGant_VL.GridNode_AddGantTime(aNode,0);
    aGT.Start:=phGant_VL.Start+30+Sin(theAxisItem.ListIndex/7)*20;
    aGT.Stop:=aGT.Start+2;
    aGT.Style:=gtsPipe;
    aGT.Color:=clRed;

    aGT:=phGant_VL.GridNode_AddGantTime(aNode,0);
    aGT.Start:=phGant_VL.Start+30+Sin(theAxisItem.ListIndex/3)*20;
    aGT.Stop:=aGT.Start+2;
    aGT.Style:=gtsPipe;
    aGT.Color:=clGreen;
  end;
end;

procedure TForm1.phGant_VLVirtualUnLoad_Grid(theCaller: TBabGridCell;
  theAxisItem: TAxisContentItem; theRowNotColumn, UnloadPerform: Boolean;
  var CanUnload: Boolean);
begin
   CanUnload:=TRUE;
end;

procedure TForm1.ButtonClearClick(Sender: TObject);
begin
  phGant1.Grid.GetTree.RootDataEntities.Clear;
end;

procedure TForm1.ButtonClearTimeItemsClick(Sender: TObject);
var
  i,ii:integer;
begin
  for i:=0 to phGant1.RowList.Count-1 do
  begin
    for ii:=0 to phGant1.RowList[i].DataLists.Count-1 do
    begin
      phGant1.RowList[i].DataLists[ii].Clear;
    end;
  end;
end;

procedure TForm1.LabelDragStartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
  DragObject:=TDragControlObjectEx.Create(LabelDrag);
  DragObject.ShowDragImage;

end;

procedure TForm1.GridDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
var
  aCell:TBabCell;
begin
  Accept:=false;
  aCell:=phGant1.Grid.MainGrid.CellFromPix(x,y);
  if Assigned(aCell) then
  begin
    if phGant1.Grid.CellToNode(aCell).ParentNode=nil then
    begin
      Accept:=true;
    end;
  end
  else
    Accept:=true;

end;

procedure TForm1.GridDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  aCell:TBabCell;
  aNode:TphDataEntity_GridTreeNode;
begin
  aCell:=phGant1.Grid.MainGrid.CellFromPix(x,y);
  if Assigned(aCell) then
  begin
    aNode:=phGant1.Grid.GetTree.InsertDataEntity(nil,phGant1.Grid.CellToNode(aCell).ListIndex);
  end
  else
  begin
    aNode:=phGant1.Grid.GetTree.AddDataEntity(nil);
  end;

  aCell:=phGant1.Grid.Cell[0,aNode.AxisContentItem.ListIndex];
  phGant1.Grid.SetText(aCell,'a new row created with drag');



end;

procedure TForm1.phGant1TimeChangeRow(theGant: TphGant_ComBasic;
  theDataEntity: TphDataEntity_GantTime; theRow, theNewRow: TGantRow;
  theStartDate, theStopDate: TDateTime);
begin
  theDataEntity.ChangeOwner(theNewRow.DataLists.Items[0],0);
end;

procedure TForm1.ButtonRowHeightClick(Sender: TObject);
var
  i:integer;
begin

  for i:=0 to phGant1.Grid.CellCountY-1 do
  begin
    if phGant1.Grid.Cell[0,i].Selected then
      phGant1.Grid.SetRowHeight(i,phGant1.Grid.GetRowHeight(i)+10);
  end;
end;

end.
